/*
 *
 *
 */

#include "sim.h"

/*
 * Oh, I'm sorry.... did you think stacks would be complicated or something?
 */ 
int pc_push(void)
{
  if (curdsp.sequencer.pc_stack_len >= 16)
    {
      fprintf(stderr, "pc_push: pc stack overflow!\n");
      set_sstat(get_sstat()|SSTAT_PC_OVERFLOW);
      return -1;
    }
  else if (get_sstat() & SSTAT_PC_EMPTY)
    set_sstat(get_sstat()^SSTAT_PC_EMPTY); /* clear Empty flag */

  /* 
   * pc_stack_len is the count. -1 for the index.  here, we're doing the next
   * so the -1 and +1 cancel...
   */ 
  curdsp.sequencer.pc_stack[curdsp.sequencer.pc_stack_len].addr = curdsp.sequencer.pc;
  return ++curdsp.sequencer.pc_stack_len;
}

unsigned int pc_peek(void)
{
  return curdsp.sequencer.pc_stack[curdsp.sequencer.pc_stack_len-1].addr;
}

unsigned int pc_pop(void)
{
  if (!curdsp.sequencer.pc_stack_len)
    return curdsp.sequencer.pc; 
  curdsp.sequencer.pc_stack_len--;
  curdsp.sequencer.pc = curdsp.sequencer.pc_stack[curdsp.sequencer.pc_stack_len].addr;
  curdsp.sequencer.pc_stack[curdsp.sequencer.pc_stack_len].addr = 0x000000;
 
  if (!curdsp.sequencer.pc_stack_len)
    curdsp.sequencer.sstat |= 0x01; /* if empty, flag it so */
  return curdsp.sequencer.pc;
}

void pc_dump(void)
{
  int i;
  fprintf(stderr, "pc_dump: --- PC Stack (%2d of 16 filled) ---\n", curdsp.sequencer.pc_stack_len);
  fprintf(stderr, "pc_dump:\tcurpc = %04x\n", curdsp.sequencer.pc);
  for (i=curdsp.sequencer.pc_stack_len-1;i>=0;i--)
    fprintf(stderr, "pc_dump:\t %2d\t%06x\n", i, curdsp.sequencer.pc_stack[i].addr);
  fprintf(stderr, "pc_dump: ----------------------------------\n");
  return;
}

void pc_zero(void)
{
  curdsp.sequencer.pc_stack_len = 0;
  memset(curdsp.sequencer.pc_stack, 0x00, sizeof(struct pc_stack_entry_s)*16);
  return;
}
